From 5e3bf0a908f712dada255f1a0773dfb2aaafc4af Mon Sep 17 00:00:00 2001
From: Osamu Aoki <osamu@debian.org>
Date: Thu, 3 Sep 2015 12:09:18 +0000
Subject: [PATCH 7/8] POD updates for pagemangle

---
 scripts/uscan.pl | 29 +++++++++++++++++++++++++++++
 1 file changed, 29 insertions(+)

diff --git a/scripts/uscan.pl b/scripts/uscan.pl
index 8b9bc74..c73fd6c 100644
--- a/scripts/uscan.pl
+++ b/scripts/uscan.pl
@@ -137,6 +137,8 @@ They behave as if a Perl command "I<$target_string> B<~=> I<rule>" is executed.
 
 =item * B<dversionmangle=>I<rule> for the last upstream version string found in F<debian/changelog>
 
+=item * B<pagemangle=>I<rule> for the downloaded web page string
+
 =item * B<uversionmangle=>I<rule> for the candidate upstream version strings
 
 =item * B<versionmangle=>I<rules> as a syntactic shorthand for:
@@ -213,6 +215,11 @@ For example, this B<http://>I<URL> may be specified as:
 
 Please note the trailing B</> in the above.
 
+If the B<pagemangle> rule exists, the whole downloaded web page as a string is
+updated by applying this rule to it.  This is very powerful tool and needs to
+be used with care.  If other mangling rules can be used to address your
+objective, do not use this rule. 
+
 The downloaded web page is scanned for links defined in the B<< <a href=" >>
 I<...> B<< "> >> tag to locate the candidate upstream tarball URLs.  These
 candidate upstream tarball URLs are matched by the Perl regex pattern
@@ -569,6 +576,28 @@ some way into one which will work automatically, for example:
   http://developer.berlios.de/project/showfiles.php?group_id=2051 \
   http://prdownload.berlios.de/softdevice/vdr-softdevice-(.+).tgz
 
+=head2 HTTP site (pagemangle)
+
+The option B<pagemangle> can be used to mangle the downloaded web page before
+applying other rules.  The non-standard web page without proper B<< <a href="
+>> << ... >> B<< "> >> entries can be converted.  For example, if F<foo.html>
+uses B<< <a bogus=" >> I<< ... >> B<< "> >>, this can be converted to the
+standard page format with:
+
+  opts=pagemangle="s/<a\s+bogus=/<a href=/g" \
+  http://example.com/release/foo.html \
+  files/foo-([\d\.]*).tar.gz
+
+Please note the use of B<g> here to replace all occurrences.
+
+If F<foo.html> uses B<< <Key> >> I<< ... >> B<< </Key> >>, this can be converted to the
+standard page format with:
+
+  opts="pagemangle=s%<Key>([^<]*)</Key>%<Key><a href="$1">$1</a></Key>%g" \\
+  http://localhost:$PORT/ \
+  (?:.*)/$PKG-([\d\.]+).tar.gz
+END
+
 =head2 FTP site (basic):
 
   opts=pasv \
-- 
2.1.4

